*-------------------------------------------------------*
*	Atari DSPBench v1.0 
*	d.m.l
*	note: just a quickly hacked-up version of NEMBench!
*-------------------------------------------------------*

	OPT		O-,W-
	COMMENT		HEAD=7
	
*-------------------------------------------------------*

	include		"macros.s"

*-------------------------------------------------------*

first_ade		=	36
off_table		=	72
data_table		=	76
form_width		=	80
form_height		=	82

cookie_jar		=	$5a0

			rsreset
STRAM_only		rs.b	1
VRAM_only		rs.b	1
STRAM_preferred		rs.b	1
VRAM_preferred		rs.b	1

enable_timing

*-------------------------------------------------------*

DCconws	macro
	move.l		\1,string_ptr
	Cconws		\1
	bsr		output_text
	endm

*-------------------------------------------------------*
*	Mark TEXT, DATA & BSS reference sections	*
*-------------------------------------------------------*
	bss
*-------------------------------------------------------*
bss_start:
*-------------------------------------------------------*
	data
*-------------------------------------------------------*
data_start:
*-------------------------------------------------------*
	text
*-------------------------------------------------------*
text_start:
*-------------------------------------------------------*
	move.l		4(sp),a5
	lea		usp_stack,sp
	lea		128(a5),a4
	move.l		a4,cli_ptr	; command string
*-------------------------------------------------------*
*	MShrink						*
*-------------------------------------------------------*
	move.l		12(a5),d0	; text segment
	add.l		20(a5),d0	; data segment
	add.l		28(a5),d0	; bss segment
	add.l		#$100,d0	; base page
	move.l		d0,-(sp)
	move.l		a5,-(sp)
	clr.w		-(sp)
	move.w		#$4a,-(sp)
	trap		#1		; mshrink
	lea		12(sp),sp
*-------------------------------------------------------*
*	Hide mouse & flush out stray keypresses		*
*-------------------------------------------------------*
	dc.w		$A00A
	jsr		flush_keybuffer
*-------------------------------------------------------*
*	Clear BSS section				*
*-------------------------------------------------------*
	jsr		clear_bss
*-------------------------------------------------------*
*	Enter supervisor mode				*
*-------------------------------------------------------*
	pea		ssp_stack
	push.w		#32
	trap		#1
	push.l		d0
*-------------------------------------------------------*
*	Initialise DSP					*
*-------------------------------------------------------*
	jsr		IsDspDrv
	dspexec		DSPTest
*-------------------------------------------------------*
	Mxalloc		#(512*1024)+256,#STRAM_only
	move.l		d0,st_buffer
	Mxalloc		#(512*1024)+256,#VRAM_only
	move.l		d0,tt_buffer
*-------------------------------------------------------*
	Cconws		#clr
	DCconws		#s1
	Cconws		#s1b
*-------------------------------------------------------*
	bsr		init_timing
*-------------------------------------------------------*
	bsr		cpu_tests
*-------------------------------------------------------*
	bsr		reset_timing
*-------------------------------------------------------*

	DCconws		#s2

	push.w		#7
	trap		#1
	addq		#2,sp

*-------------------------------------------------------*
super_return:
*-------------------------------------------------------*
	push.w		#32
	trap		#1
	lea		10(sp),sp
*-------------------------------------------------------*
user_return:
*-------------------------------------------------------*
	dc.w		$A009
	clr.w		-(sp)
	trap		#1

test	macro
	move.l		#\1-1,d0
.ol\@:
	i_\4
	move.w		#\2-1,d7
.il\@:	
	rept		\3
	t_\4
	endr	
	nop
	fnop
	dbra		d7,.il\@
	subq.l		#1,d0
	bne		.ol\@
	endm

*-------------------------------------------------------*
cpu_tests:
*-------------------------------------------------------*

	rept		0

	bsr		multiply_int_16
	bsr		divide_int_16
	bsr		arithmetic_op
	bsr		mixed_op

	move.l		#'_FPU',d0
	bsr		cookie_search
	tst.l		4(a0)
	beq.s		.nfpu

	DCconws		#b0
	bsr		multiply_float
	bsr		divide_float
	bsr		arithmetic_float
	bsr		mixed_float

.nfpu:
	DCconws		#b0
	bsr		word_read
	bsr		word_write
	bsr		longword_read
	bsr		longword_write
	bsr		linear_stread
	bsr		linear_stwrite
	bsr		linear_sttransfer
	bsr		linear_ttread
	bsr		linear_ttwrite
	bsr		linear_tttransfer

	endr
	
	DCconws		#b0
	bsr		dsp_tests

*-------------------------------------------------------*
	clr.w		file_handle
*-------------------------------------------------------*
	push.w		#0
	pea		file
	push.w		#60
	trap		#1
	addq.l		#8,sp
	tst.l		d0
	bmi		.err
	move.w		d0,file_handle
*-------------------------------------------------------*
	move.l		txtbuff_ptr,d0
	sub.l		#text_buffer,d0
	pea		text_buffer
	push.l		d0
	push.w		file_handle
	push.w		#64
	trap		#1
	lea		12(sp),sp
*-------------------------------------------------------*
	tst.w		file_handle
	beq.s		.err
	push.w		file_handle
	push.w		#62
	trap		#1
	addq.l		#4,sp
*-------------------------------------------------------*
.err:	rts

*---------------------------------------------------------------*
*	Search jar for specific cookie				*
*---------------------------------------------------------------*
cookie_search:
*---------------------------------------------------------------*
	move.l		cookie_jar.w,a0
.loop:	cmp.l		(a0),d0
	beq.s		.find
	tst.l		(a0)
	beq.s		.fail
	addq.l		#8,a0
	bra.s		.loop
.find:	moveq		#0,d0
	bra.s		.end
.fail:	moveq		#-1,d0
.end:	rts

i_imul	macro
	moveq		#2,d1
	moveq		#1,d2
	moveq		#1,d3
	moveq		#1,d4
	moveq		#1,d5
	endm

t_imul	macro
	mulu.w		d1,d2
	mulu.w		d1,d3
	mulu.w		d1,d4
	mulu.w		d1,d5
	endm

i_idiv	macro
	moveq		#2,d1
	move.l		#$00008765,d2
	move.l		d2,d3
	move.l		d2,d4
	move.l		d2,d5
	endm

t_idiv	macro
	divu.w		d1,d2
	divu.w		d1,d3
	divu.w		d1,d4
	divu.w		d1,d5
	endm

i_ilin	macro
	endm

t_ilin	macro
	add.l		d1,d2
	or.l		d1,d2
	cmp.l		d1,d2
	move.l		d1,d2
	endm

i_imix	macro
	endm

t_imix	macro
	add.l		d1,d2
	or.l		d3,d4
	cmp.l		d0,d7
	move.l		d5,d6
	endm

i_fmul	macro
	fmove.w		#3,fp0
	fmove.x		#0.0077777777,fp1
	fmove.x		fp1,fp2
	fmove.x		fp1,fp3
	fmove.x		fp1,fp4
	endm

t_fmul	macro
	fmul.x		fp0,fp1
	fmul.x		fp0,fp2
	fmul.x		fp0,fp3
	fmul.x		fp0,fp4
	endm

i_fdiv	macro
	fmove.w		#3,fp0
	fmove.l		#7777777777,fp1
	fmove.x		fp1,fp2
	fmove.x		fp1,fp3
	fmove.x		fp1,fp4
	endm

t_fdiv	macro
	fdiv.x		fp0,fp1
	fdiv.x		fp0,fp2
	fdiv.x		fp0,fp3
	fdiv.x		fp0,fp4
	endm

i_flin	macro
	fmove.x		#1.5,fp0
	fmove.x		#2.7,fp1
	endm

t_flin	macro
	fadd.x		fp0,fp1
	fsub.x		fp0,fp1
	fcmp.x		fp0,fp1
	fmove.x		fp0,fp1
	endm

i_fmix	macro
	fmove.x		#1.5,fp0
	fmove.x		#2.7,fp1
	fmove.x		#3.9,fp2
	fmove.x		#5.2,fp3
	fmove.x		#6.9,fp4
	fmove.x		#8.1,fp5
	fmove.x		#8.7,fp6
	fmove.x		#9.6,fp7
	endm

t_fmix	macro
	fadd.x		fp0,fp1
	fsub.x		fp2,fp3
	fcmp.x		fp6,fp7
	fmove.x		fp4,fp5
	endm

i_wread	macro
	endm

t_wread	macro
	move.w		(a0),d1
	move.w		(a0),d2
	move.w		(a0),d3
	move.w		(a0),d4
	endm

i_wwrit	macro
	endm

t_wwrit	macro
	move.w		d1,(a0)
	move.w		d2,(a0)
	move.w		d3,(a0)
	move.w		d4,(a0)
	endm

i_lread	macro
	endm

t_lread	macro
	move.l		(a0),d1
	move.l		(a0),d2
	move.l		(a0),d3
	move.l		(a0),d4
	endm

i_lwrit	macro
	endm

t_lwrit	macro
	move.l		d1,(a0)
	move.l		d2,(a0)
	move.l		d3,(a0)
	move.l		d4,(a0)
	endm

i_slbr	macro
	move.l		a1,a0
	endm

t_slbr	macro
	move.l		(a0)+,d1
	move.l		(a0)+,d2
	move.l		(a0)+,d3
	move.l		(a0)+,d4
	endm

i_slbw	macro
	move.l		a1,a0
	endm

t_slbw	macro
	move.l		d1,(a0)+
	move.l		d1,(a0)+
	move.l		d1,(a0)+
	move.l		d1,(a0)+
	endm

i_slbt	macro
	move.l		a1,a0
	move.l		a2,a3
	endm

t_slbt	macro
	move.l		(a0)+,(a3)+
	move.l		(a0)+,(a3)+
	move.l		(a0)+,(a3)+
	move.l		(a0)+,(a3)+
	endm

*-------------------------------------------------------*
multiply_int_16:
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		160000,2,4,imul
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		160000,2,0,imul
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#5120000,d1
;			 iiffffff
	move.l		#00616000,d2
	lea		ascii_intmul,a0
	bsr		print_time
	rts

*-------------------------------------------------------*
divide_int_16:
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		160000,1,4,idiv
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		160000,1,0,idiv
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#2560000,d1
;			 iiffffff
	move.l		#00363000,d2
	lea		ascii_intdiv,a0
	bsr		print_time
	rts

*-------------------------------------------------------*
arithmetic_op:
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		160000,4,16,ilin
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		160000,4,0,ilin
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#40960000,d1
;			 iiffffff
	move.l		#07984000,d2
	lea		ascii_arithmetic,a0
	bsr		print_time
	rts

*-------------------------------------------------------*
mixed_op:
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		160000,4,16,imix
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		160000,4,0,imix
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#40960000,d1
;			 iiffffff
	move.l		#07984000,d2
	lea		ascii_mixed,a0
	bsr		print_time
	rts

*-------------------------------------------------------*
multiply_float:
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		3200,40,8,fmul
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		3200,40,0,fmul
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#4096000,d1
;			 iiffffff
	move.l		#00265000,d2
	lea		ascii_fmul,a0
	bsr		print_flops
	rts

*-------------------------------------------------------*
divide_float:
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		800,40,8,fdiv
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		800,40,0,fdiv
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#1024000,d1
;			 iiffffff
	move.l		#00173000,d2
	lea		ascii_fdiv,a0
	bsr		print_flops
	rts

*-------------------------------------------------------*
arithmetic_float:
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		3200,40,8,flin
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		3200,40,0,flin
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#4096000,d1
;			 iiffffff
	move.l		#00533000,d2
	lea		ascii_farith,a0
	bsr		print_flops
	rts

*-------------------------------------------------------*
mixed_float:
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		3200,40,8,fmix
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		3200,40,0,fmix
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#4096000,d1
;			 iiffffff
	move.l		#00532000,d2
	lea		ascii_fmixed,a0
	bsr		print_flops
	rts

total_time:	ds.l	1

*-------------------------------------------------------*
word_read:
*-------------------------------------------------------*
	move.l		tt_buffer,d0
	bne.s		.ok
	move.l		st_buffer,d0
.ok:	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a0
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		100,8000,16,wread
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		100,8000,0,wread
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#(102400000/1024)*1000,d1
;			 iiffffff
	move.l		#07886000,d2
	lea		ascii_cwr,a0
	bsr		print_bandwidth
	rts

*-------------------------------------------------------*
word_write:
*-------------------------------------------------------*
	move.l		tt_buffer,d0
	bne.s		.ok
	move.l		st_buffer,d0
.ok:	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a0
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		25,8000,16,wwrit
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		25,8000,0,wwrit
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#(25600000/1024)*1000,d1
;			 iiffffff
	move.l		#05980000,d2
	lea		ascii_cww,a0
	bsr		print_bandwidth
	rts

*-------------------------------------------------------*
longword_read:
*-------------------------------------------------------*
	move.l		tt_buffer,d0
	bne.s		.ok
	move.l		st_buffer,d0
.ok:	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a0
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		100,4000,16,lread
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		100,4000,0,lread
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#(102400000/1024)*1000,d1
;			 iiffffff
	move.l		#15760000,d2
	lea		ascii_clr,a0
	bsr		print_bandwidth
	rts

*-------------------------------------------------------*
longword_write:
*-------------------------------------------------------*
	move.l		tt_buffer,d0
	bne.s		.ok
	move.l		st_buffer,d0
.ok:	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a0
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		25,4000,16,lwrit
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		25,4000,0,lwrit
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#(25600000/1024)*1000,d1
;			 iiffffff
	move.l		#06640000,d2
	lea		ascii_clw,a0
	bsr		print_bandwidth
	rts

*-------------------------------------------------------*
linear_stread:
*-------------------------------------------------------*
	move.l		st_buffer,d0
	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a1
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,1024,16,slbr
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,1024,0,slbr
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#((1024*256*(4*4*16))/1024)*1000,d1
;			 iiffffff
	move.l		#05268000,d2
	lea		ascii_slbr,a0
	bsr		print_bandwidth
	rts

*-------------------------------------------------------*
linear_stwrite:
*-------------------------------------------------------*
	move.l		st_buffer,d0
	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a1
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,1024,16,slbw
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,1024,0,slbw
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#((1024*256*(4*4*16))/1024)*1000,d1
;			 iiffffff
	move.l		#06393000,d2
	lea		ascii_slbw,a0
	bsr		print_bandwidth
	rts

*-------------------------------------------------------*
linear_sttransfer:
*-------------------------------------------------------*
	move.l		st_buffer,d0
	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a1
	move.l		a1,a2
	add.l		#256*1024,a2
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,512,16,slbt
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,512,0,slbt
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#((512*256*(4*4*16))/1024)*1000,d1
;			 iiffffff
	move.l		#03200000,d2
	lea		ascii_slbt,a0
	bsr		print_bandwidth
	rts

*-------------------------------------------------------*
linear_ttread:
*-------------------------------------------------------*
	move.l		tt_buffer,d0
	beq		.err
	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a1
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,2048,16,slbr
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,2048,0,slbr
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#((2048*256*(4*4*16))/1024)*1000,d1
;			 iiffffff
	move.l		#05268000,d2
	lea		ascii_tlbr,a0
	bsr		print_bandwidth
.err:	rts

*-------------------------------------------------------*
linear_ttwrite:
*-------------------------------------------------------*
	move.l		tt_buffer,d0
	beq		.err
	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a1
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,2048,16,slbw
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,2048,0,slbw
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#((2048*256*(4*4*16))/1024)*1000,d1
;			 iiffffff
	move.l		#06393000,d2
	lea		ascii_tlbw,a0
	bsr		print_bandwidth
.err:	rts

*-------------------------------------------------------*
linear_tttransfer:
*-------------------------------------------------------*
	move.l		tt_buffer,d0
	beq		.err
	add.l		#16-1,d0
	and.l		#-16,d0
	move.l		d0,a1
	move.l		a1,a2
	add.l		#256*1024,a2
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,1024,16,slbt
	move.l		fpsc,total_time
*-------------------------------------------------------*
	bsr		wait_td
	clr.l		fpsc
	test		256,1024,0,slbt
	move.l		fpsc,d0
*-------------------------------------------------------*
	neg.l		d0
	add.l		total_time,d0
*-------------------------------------------------------*
	move.l		#((1024*256*(4*4*16))/1024)*1000,d1
;			 iiffffff
	move.l		#03200000,d2
	lea		ascii_tlbt,a0
	bsr		print_bandwidth
.err:	rts
	
*-------------------------------------------------------*
dsp_tests:
*-------------------------------------------------------*
	bsr		wait_td
*-------------------------------------------------------*
*	DSP tests					*
*-------------------------------------------------------*
	dspwrite.w	d0
	dspread.w	d0
*-------------------------------------------------------*
*	X internal / Y internal / P internal		*	
*-------------------------------------------------------*
	clr.l		fpsc
	dspwrite.w	d0
	dspread.w	d0
	move.l		fpsc,d0
	lea		ascii_dsp_iii,a0
	move.l		#256000000,d1
	move.l		#16000000,d2
	bsr		print_time
*-------------------------------------------------------*
*	X external / Y internal / P internal		*	
*-------------------------------------------------------*
	clr.l		fpsc
	dspwrite.w	d0
	dspread.w	d0
	move.l		fpsc,d0
	lea		ascii_dsp_eii,a0
	move.l		#256000000,d1
	move.l		#16000000,d2
	bsr		print_time
*-------------------------------------------------------*
*	X internal / Y external / P internal		*	
*-------------------------------------------------------*
	clr.l		fpsc
	dspwrite.w	d0
	dspread.w	d0
	move.l		fpsc,d0
	lea		ascii_dsp_iei,a0
	move.l		#256000000,d1
	move.l		#16000000,d2
	bsr		print_time
*-------------------------------------------------------*
*	X external / Y external / P internal		*	
*-------------------------------------------------------*
	clr.l		fpsc
	dspwrite.w	d0
	dspread.w	d0
	move.l		fpsc,d0
	lea		ascii_dsp_eei,a0
	move.l		#256000000,d1
	move.l		#16000000/2,d2
	bsr		print_time


*-------------------------------------------------------*
*	X internal / Y internal / P external		*	
*-------------------------------------------------------*
	clr.l		fpsc
	dspwrite.w	d0
	dspread.w	d0
	move.l		fpsc,d0
	lea		ascii_dsp_iie,a0
	move.l		#256000000,d1
	move.l		#16000000,d2
	bsr		print_time
*-------------------------------------------------------*
*	X external / Y internal / P external		*	
*-------------------------------------------------------*
	clr.l		fpsc
	dspwrite.w	d0
	dspread.w	d0
	move.l		fpsc,d0
	lea		ascii_dsp_eie,a0
	move.l		#256000000,d1
	move.l		#16000000/2,d2
	bsr		print_time
*-------------------------------------------------------*
*	X internal / Y external / P external		*	
*-------------------------------------------------------*
	clr.l		fpsc
	dspwrite.w	d0
	dspread.w	d0
	move.l		fpsc,d0
	lea		ascii_dsp_iee,a0
	move.l		#256000000,d1
	move.l		#16000000/2,d2
	bsr		print_time
*-------------------------------------------------------*
*	X external / Y external / P external		*	
*-------------------------------------------------------*
	clr.l		fpsc
	dspwrite.w	d0
	dspread.w	d0
	move.l		fpsc,d0
	lea		ascii_dsp_eee,a0
	move.l		#256000000,d1
	move.l		#16000000/3,d2
	bsr		print_time
	rts

*-------------------------------------------------------*
wait_td:
*-------------------------------------------------------*
	clr.l		fpsc
.wt:	cmp.l		#2,fpsc
	bne.s		.wt
	rts

print_time:
	tst.l		d0
	beq		.err

;	divu.l		#100/2,d1
	divu.l		#10/2,d1

	divu.l		#1000,d2

	divu.l		d0,d1
	move.l		d1,d0

	move.l		#text_space,numtext_ptr


	pushall
	push.l		d0
	push.l		d2
	lea		b2,a0
	bsr		pushtext
	pop.l		d2
	pop.l		d0

	mulu.l		#1000,d0
	divu.l		d2,d0

	add.l		#5,d0
	divu.l		#10,d0

	moveq		#1,d7
	bsr		pushdigits
	lea		b1,a0
	bsr		pushtext
	popall


	push.l		a0

	push.l		d0
	lea		time1,a0
	bsr		pushtext
	pop.l		d0

	push.l		d0

	divu.w		#1000,d0
	swap		d0
	ext.l		d0
	moveq		#3,d7
	bsr		pushdigits
	pop.l		d0

	push.l		d0
	lea		dot,a0
	bsr		pushtext
	pop.l		d0

	push.l		d0
	divu.l		#1000,d0
	moveq		#1,d7
	bsr		pushdigits
	pop.l		d0

	pop.l		a0
	
	push.l		d0
	bsr		pushtext
	pop.l		d0

	DCconws		numtext_ptr

.err:	rts

print_flops:
	tst.l		d0
	beq		.err

;	divu.l		#100/2,d1
	divu.l		#10/2,d1

	divu.l		#1000,d2

	divu.l		d0,d1
	move.l		d1,d0

	move.l		#text_space,numtext_ptr


	pushall
	push.l		d0
	push.l		d2
	lea		b2,a0
	bsr		pushtext
	pop.l		d2
	pop.l		d0

	mulu.l		#1000,d0
	divu.l		d2,d0

	add.l		#5,d0
	divu.l		#10,d0

	moveq		#1,d7
	bsr		pushdigits
	lea		b1,a0
	bsr		pushtext
	popall


	push.l		a0

	push.l		d0
	lea		time3,a0
	bsr		pushtext
	pop.l		d0

	push.l		d0

	divu.w		#1000,d0
	swap		d0
	ext.l		d0
	moveq		#3,d7
	bsr		pushdigits
	pop.l		d0

	push.l		d0
	lea		dot,a0
	bsr		pushtext
	pop.l		d0

	push.l		d0
	divu.l		#1000,d0
	moveq		#1,d7
	bsr		pushdigits
	pop.l		d0

	pop.l		a0
	
	push.l		d0
	bsr		pushtext
	pop.l		d0

	DCconws		numtext_ptr

.err:	rts

print_bandwidth:
	tst.l		d0
	beq		.err

;	divu.l		#100/2,d1
	divu.l		#10/2,d1

	divu.l		#1000,d2

	divu.l		d0,d1
	move.l		d1,d0

	move.l		#text_space,numtext_ptr


	pushall
	push.l		d0
	push.l		d2
	lea		b2,a0
	bsr		pushtext
	pop.l		d2
	pop.l		d0

	mulu.l		#1000,d0
	divu.l		d2,d0

	add.l		#5,d0
	divu.l		#10,d0

	moveq		#1,d7
	bsr		pushdigits
	lea		b1,a0
	bsr		pushtext
	popall


	push.l		a0

	push.l		d0
	lea		time2,a0
	bsr		pushtext
	pop.l		d0

	push.l		d0

	divu.w		#1000,d0
	swap		d0
	ext.l		d0
	moveq		#3,d7
	bsr		pushdigits
	pop.l		d0

	push.l		d0
	lea		dot,a0
	bsr		pushtext
	pop.l		d0

	push.l		d0
	divu.l		#1000,d0
	moveq		#1,d7
	bsr		pushdigits
	pop.l		d0

	pop.l		a0
	
	push.l		d0
	bsr		pushtext
	pop.l		d0

	DCconws		numtext_ptr

.err:	rts

*-------------------------------------------------------*
output_text:
*-------------------------------------------------------*
	pushall
	move.l		string_ptr,a0
	move.l		txtbuff_ptr,a1
.copy:	move.b		(a0)+,(a1)+
	bne.s		.copy
	subq.l		#1,a1
	move.l		a1,txtbuff_ptr
	popall
	rts

txtbuff_ptr:	dc.l	text_buffer

*-------------------------------------------------------*
*	Core program modules				*
*-------------------------------------------------------*

	include		"timing.s"
	include		"dsplib.s"
	include		"sys.s"
	include		"end.s"

DSPTest:		incbin	"dsptest.dsp"
DSPTest_e:		even

b0:		dc.b		13,10,0
b1:		dc.b		'(~',0
b2:		dc.b		'%)',13,10,0
s1:		dc.b		'DSPBench v2.0 - precision DSP profiler.',13,10,0
s1b:		dc.b		'Please wait while your machine is tested...',13,10,0
s2:		dc.b		13,10,'Testing is complete! ',0
dot:		dc.b		'.',0

clr:		dc.b		27,'E',0

time1:		dc.b		' Mips ',0
time2:		dc.b		' MByte/sec ',0
time3:		dc.b		' MegaFlops ',0
	
ascii_intmul:		dc.b		'Integer multiply (16bit)     -> ',0
ascii_intdiv:		dc.b		'Integer divide (16bit)       -> ',0
ascii_arithmetic:	dc.b		'Linear (stalled) integer     -> ',0
ascii_mixed:		dc.b		'Interleaved (piped) integer  -> ',0

ascii_fmul:		dc.b		'Float multiply (64bit)       -> ',0
ascii_fdiv:		dc.b		'Float divide (64bit)         -> ',0
ascii_farith:		dc.b		'Linear (stalled) float       -> ',0
ascii_fmixed:		dc.b		'Interleaved (piped) float    -> ',0

ascii_cwr:		dc.b		'16bit read (100% hit)        -> ',0
ascii_cww:		dc.b		'16bit write (100% hit)       -> ',0
ascii_clr:		dc.b		'32bit read (100% hit)        -> ',0
ascii_clw:		dc.b		'32bit write (100% hit)       -> ',0

ascii_slbr:		dc.b		'Linear 256k read (STRam)     -> ',0
ascii_slbw:		dc.b		'Linear 256k write (STRam)    -> ',0
ascii_slbt:		dc.b		'Linear 256k copy (STRam)     -> ',0
ascii_tlbr:		dc.b		'Linear 256k read (FastRAM)   -> ',0
ascii_tlbw:		dc.b		'Linear 256k write (FastRAM)  -> ',0
ascii_tlbt:		dc.b		'Linear 256k copy (FastRAM)   -> ',0

ascii_dsp_iii:		dc.b		'DSP ( X:Int Y:Int P:Int )    -> ',0
ascii_dsp_eii:		dc.b		'DSP ( X:Ext Y:Int P:Int )    -> ',0
ascii_dsp_iei:		dc.b		'DSP ( X:Int Y:Ext P:Int )    -> ',0
ascii_dsp_eei:		dc.b		'DSP ( X:Ext Y:Ext P:Int )    -> ',0

ascii_dsp_iie:		dc.b		'DSP ( X:Int Y:Int P:Ext )    -> ',0
ascii_dsp_eie:		dc.b		'DSP ( X:Ext Y:Int P:Ext )    -> ',0
ascii_dsp_iee:		dc.b		'DSP ( X:Int Y:Ext P:Ext )    -> ',0
ascii_dsp_eee:		dc.b		'DSP ( X:Ext Y:Ext P:Ext )    -> ',0

file:			dc.b		'dspbench.out',0
			even



*-------------------------------------------------------*
			bss
*-------------------------------------------------------*

*-------------------------------------------------------*
*	System-use variables				*
*-------------------------------------------------------*

st_buffer:		ds.l		1
tt_buffer:		ds.l		1
temp:			ds.l		16

			ds.b		256
text_space:		ds.b		256

os_screen_w:		ds.w		1
os_screen_h:		ds.w		1

file_handle:		ds.w		1
string_ptr:		ds.l		1	

text_buffer:		ds.b		16384

*-------------------------------------------------------*

