*=======================================================*
*	Timing module: latest update 25/03/96		*
*=======================================================*
*	Interrupts for timing & synchronisation		*
*=======================================================*

timerb		=	$120
timerc		=	$114

tbcr		=	$fffffa1b
cdcr		=	$fffffa1d
tbdr		=	$fffffa21
tcdr		=	$fffffa23
iera		=	$fffffa07
ierb		=	$fffffa09
imra		=	$fffffa13
imrb		=	$fffffa15
isra		=	$fffffa0f

frames_per_sec

*-------------------------------------------------------*
init_timing:
*-------------------------------------------------------*
	push.w		sr
	or.w		#$700,sr

	move.b		iera.w,old_iera
	move.b		ierb.w,old_ierb
	move.b		imra.w,old_imra
	move.b		imrb.w,old_imrb

	ifd		debug
	move.l		$4d2.w,old_vbi
	move.l		#new_vbi,$4d2.w
	elseif
	move.l		$70.w,old_vbi
	move.l		#new_vbi,$70.w

	move.l		timerc.w,old_timerc
	move.l		#framecounter,timerc.w

	move.b		#%00000000,iera
	move.b		#%00000000,imra
	move.b		#%01100000,ierb
	move.b		#%01100000,imrb

;	and.b		#%00001111,cdcr.w
;	and.b		#%00001111,cdcr.w

	move.b		#%00000000,cdcr.w
	move.b		#192,tcdr.w		; 2457600/192 = 12800Hz
;	or.b		#%01010000,cdcr.w	; 12800/64 = 200Hz
	move.b		#%01010000,cdcr.w	; 12800/64 = 200Hz

	endc

	pop.w		sr
	rts

*-------------------------------------------------------*
reset_timing:
*-------------------------------------------------------*
	push.w		sr
	or.w		#$700,sr


	ifd		debug
	move.l		old_vbi,$4d2.w
	elseif
	move.l		old_vbi,$70.w

	move.l		old_timerc,timerc.w

	move.b		old_iera,iera.w
	move.b		old_ierb,ierb.w
	move.b		old_imra,imra.w
	move.b		old_imrb,imrb.w

;	and.b		#%00001111,cdcr.w
;	move.b		#192,tcdr.w		; 2457600/192 = 12800Hz
;	or.b		#%01010000,cdcr.w	; 12800/64 = 200Hz

	move.b		#%00000000,cdcr.w
	move.b		#192,tcdr.w		; 2457600/192 = 12800Hz
	move.b		#%01010001,cdcr.w	; 12800/64 = 200Hz

	endc

	pop.w		sr
	rts
	
*-------------------------------------------------------*
pushdigits:
*-------------------------------------------------------*
;	d0 	= 	number
	move.l		numtext_ptr,a0
	move.l		a0,a1
	moveq		#'0',d3
	move.l		d3,d1
	moveq		#10,d4
	tst.l		d0
	beq.s		.zero
.loop	swap		d0
	clr.w		d0
	swap		d0
	divu		d4,d0
	move.l		d0,d1
	swap		d1
	add.w		d3,d1
.zero:	move.b		d1,-(a0)
	subq.l		#1,d7
	bgt.s		.loop
	tst.w		d0
	bne.s		.loop
	move.l		a0,numtext_ptr
	rts

*-------------------------------------------------------*
pushtext:
*-------------------------------------------------------*
	move.l		numtext_ptr,a1
	moveq		#-1,d0
.lp	addq.l		#1,d0
	tst.b		(a0)+
	bne.s		.lp
	subq.l		#1,a0
	bra.s		.go
.cop:	move.b		-(a0),-(a1)
.go:	dbra		d0,.cop
	move.l		a1,numtext_ptr
	rts
	
*-------------------------------------------------------*
framecounter:
*-------------------------------------------------------*
	addq.l		#1,fpsc
	ifd		debug
	jmp		([old_timerc.l])
	elseif
	bclr		#5,$FFFFFA11.w
	rte
	endc

*-------------------------------------------------------*
new_vbi:
*-------------------------------------------------------*
	tst.w		timer
	beq.s		.nd
	subq.w		#1,timer
.nd:	addq.l		#1,vbls
	addq.w		#1,frame
	ifnd		debug
	addq.l		#1,$462.w
	addq.l		#1,$466.w
	elseif
	addq.l		#4,fpsc
	endc
*-------------------------------------------------------*
bypass_vbi:
*-------------------------------------------------------*
	ifd		debug
	rts
	elseif
	rte
	endc

*-------------------------------------------------------*
			data
*-------------------------------------------------------*

fpsc:			dc.l	0
	
fps:			dc.b	" FPS",0
frames:			dc.b	" VBL",0
point:			dc.b	".",0
			even

*-------------------------------------------------------*
			bss
*-------------------------------------------------------*

old_vbi:		ds.l	1
old_timerb:		ds.l	1
old_timerc:		ds.l	1
numtext_ptr:		ds.l	1
fontptr:		ds.l	1

screen:			ds.l	1

vbls:			ds.l	1
ovbls:			ds.l	1
fpso:			ds.l	1
fc_history:		ds.l	8

scrwidth:		ds.w	1
frame:			ds.w	1

timer:			ds.w	1
char_x:			ds.w	1
char_y:			ds.w	1
char_col:		ds.w	1
textgap:		ds.w	1

			ds.b	256
stringspace:		ds.b	1

old_iera:		ds.b	1
old_ierb:		ds.b	1
old_imra:		ds.b	1
old_imrb:		ds.b	1
			even

*-------------------------------------------------------*
			text
*-------------------------------------------------------*
